# Create fulfillments Creates one or multiple Fulfillment objects. You can also generate invoices or memos for these Fulfillment objects in this API call. The following tutorials demonstrate how to use this operation: * Create a sales order line item with fulfillments * Create a return order line item with fulfillments Endpoint: POST /v1/fulfillments Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Idempotency-Key` (string) Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident. - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) The minor API version. For a list of available minor versions, see API upgrades. ## Request fields (application/json): - `fulfillments` (array) Example: [{"billTargetDate":"2022-01-01","fulfillmentDate":"2022-01-01","fulfillmentType":"Delivery","orderLineItemId":"4028828c82819b740182821bb23e15c4","quantity":5,"state":"SentToBilling"},{"billTargetDate":"2022-01-01","fulfillmentDate":"2022-01-01","fulfillmentType":"Delivery","orderLineItemId":"4028828c82819b740182821bb23e15c4","quantity":5,"state":"SentToBilling"}] - `fulfillments.orderLineItemId` (string) The reference id of the related Order Line Item. - `fulfillments.billTargetDate` (string) The target date for the Fulfillment to be picked up by bill run for billing. - `fulfillments.carrier` (string) The carrier of the Fulfillment. The available values can be configured in Billing Settings > Fulfillment Settings through Zuora UI. - `fulfillments.customFields` (object) Container for custom fields of a Fulfillment object. - `fulfillments.description` (string) The description of the Fulfillment. - `fulfillments.excludeItemBillingFromRevenueAccounting` (boolean) The flag to exclude Fulfillment related invoice items, invoice item adjustments, credit memo items, and debit memo items from revenue accounting. Note: This field is only available if you have the Order to Revenue or [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration) feature enabled. - `fulfillments.excludeItemBookingFromRevenueAccounting` (boolean) The flag to exclude Fulfillment from revenue accounting. Note: This field is only available if you have the Order to Revenue or [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration) feature enabled. - `fulfillments.externalId` (string) The external id of the Fulfillment. - `fulfillments.fulfillmentDate` (string) The date of the Fulfillment. - `fulfillments.fulfillmentLocation` (string) The fulfillment location of the Fulfillment. The available values can be configured in Billing Settings > Fulfillment Settings through Zuora UI. - `fulfillments.fulfillmentSystem` (string) The fulfillment system of the Fulfillment. The available values can be configured in Billing Settings > Fulfillment Settings through Zuora UI. - `fulfillments.fulfillmentType` (string) The type of the Fulfillment. Enum: "Delivery", "Return" - `fulfillments.quantity` (number) The quantity of the Fulfillment. - `fulfillments.state` (string) The state of the Fulfillment. See [State transitions for an order, order line item, and fulfillment](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items/AB_Order_Line_Item_States_and_Order_States) for more information. Enum: "Executing", "Booked", "SentToBilling", "Complete", "Cancelled" - `fulfillments.trackingNumber` (string) The tracking number of the Fulfillment. - `fulfillments.fulfillmentItems` (array) - `fulfillments.fulfillmentItems.customFields` (object) Container for custom fields of a Fulfillment Item object. - `fulfillments.fulfillmentItems.description` (string) The description of the Fulfillment Item. - `fulfillments.fulfillmentItems.itemIdentifier` (string) The external identifier of the Fulfillment Item. - `processingOptions` (object) Processing options for generating billing documents. - `processingOptions.billingOptions` (object) - `processingOptions.billingOptions.documentDate` (string) The invoice date displayed on the billing document. - `processingOptions.billingOptions.targetDate` (string) Date through which to calculate charges for order line items if a billing document is generated. See [What is a Target Date?](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/G_Bill_Runs/Creating_Bill_Runs#What_is_a_Target_Date.3F). - `processingOptions.runBilling` (boolean) Indicates if the current request needs to generate a billing document. The billing document will be generated against all Order Line Items included in this order. ## Response 200 fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded. - `creditMemoNumbers` (array) An array of the credit memo numbers generated in this request. The credit memo is only available if you have the Invoice Settlement feature enabled. - `fulfillments` (array) - `fulfillments.fulfillmentItems` (array) - `fulfillments.fulfillmentItems.id` (string) The sytem generated Id. - `fulfillments.fulfillmentNumber` (string) The sytem generated number for the Fulfillment. - `invoiceNumbers` (array) An array of the invoice numbers generated in this request. Normally it includes one invoice number only. - `paidAmount` (number) The total amount collected in this request. - `paymentNumber` (string) The payment number collected in this request. ## Response 500 fields (application/json): - `reasons` (array) Example: [{"code":"ObjectNotFound","message":"Notification definition with id 6e569e1e05f040eda51a927b140c0ac1 does not exist"}] - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response ## Response 4XX fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded.